Subject: Re: bug#20802: Segfault when showing non-GTK+ tooltip

From: Eli Zaretskii <[email-masked]>
Date: Sun, 14 Jun 2015 17:12:55 +0300

> Date: Sun, 14 Jun 2015 13:00:57 +0200
> From: martin rudalics <[email-masked]>
> CC: [email-masked], [email-masked]
> 
> What happens is given in the backtraces below.  The first breakpoint is
> hit when Emacs creates the image cache for the original frame
> (f=0x13a7e00).  The second breakpoint is hit when freeing the image
> cache for the tooltip frame (f=0xe0c7a0).  This removes the image_cache
> created in make_image_cache at 0x1676f90.  The third breakpoint is the
> same as in my earlier posts.
> 
> The reason seems obvious: When the color is not defined for the tooltip
> frame we do _not_ increment the refcount of the image cache.  But we
> subsequently free the image cache in unwind_create_frame.  Bad luck.

Thanks.  Now I know why this cannot be reproduced on Windows: this is
bug#17524 coming back to haunt us.  That bug was reported on Windows,
I fixed it on Windows, then suggested a similar fix for X, but was
told it didn't help there.

So now please try making a fix on X similar to commit ebdc80316, and
if that indeed doesn't help with this crash, perhaps some simple
variation of that will.

TIA